#include <stdlib.h>
#include <stdio.h>
#include <string.h>
//#include <miracl.h>
#include <time.h>
#include <ctype.h>

#include <kernel.h>
#include <swis.h>
#include <unixlib/os.h>

#include "Decrypt.h"
#include "Encode.h"

typedef enum _SAVETYPE
{
  SAVETYPE_INVALID = -1,
  SAVETYPE_FILE,
  SAVETYPE_PASSWORD,
  SAVETYPE_NUM
} SAVETYPE;

char                          gpcTemp[512];
static char                   *pcMessages;
static int                    gwhMain;
static int                    gwhSave;
static int                    gwhPass;
static int                    gwhList;
static int                    gwhWarn;
static int                    gnMenuWins = 0;
static int                    gawhMenuWinHandle[10];
static int                    gnMenuXpos = 0;
static int                    gnMenuYpos = 0;
static char *                 gpcMenuCurrent = NULL;
static char *                 gpcIconBarMenu;
static int                    gnTaskHandle;
static BOOL                   gboDrag = FALSE;
static SAVETYPE               geSaveType = SAVETYPE_INVALID;
static int                    gnSaveFileType;
static char                   gacFontRef[256];
static char                   *gpcSprites;
static int                    gnMessageMyRef = 0;
static BOOL                   gboWarnQuit = FALSE;

#define LISTXOFFSET           (+20)
#define LISTYOFFSET           (+20)
#define LISTITEMYGAP          (-2)

void    CloseWindowHandle     (int whWindow);
void    MainCancel            (void);
void    SaveSave              (void);
void    PassSave              (void);
void    PassCancel            (void);
void    Drag                  (int whWindow, int ihIcon, char * szIconName);
void    Passwords             (void);
void    OpenMainWindow        (void);
void    AddFileToList         (char * szName, char * szSpriteName);
void    MainSave              (int nXpos, int nYpos);
void    OpenWindowInitCentre  (int whWindow);
void    OpenWebsite           (void);
void    OpenCDFiler           (void);
void    DragBox               (int whWindow, int ihIcon);
void    Acknowledged          (char * cBlock);
void    DragCentred           (int nXpos, int nYpos, char * szIconName);
void    ListSave              (int nXpos, int nYpos, int ihIcon);

//////////////////////////////////////////////////////////////////
// Main application

inline void err (_kernel_oserror * sError)
{
  if (sError)
  {
    ShowError (sError);
  }
}

int main(int argc, char * * argv)
{
  _kernel_swi_regs sRegs;
  _kernel_oserror  *psError;
  char             cBlock[256];
  int              nVersion;
  int              anUserMessages[] = {2, 6, 0x502, 0x4af80, 0};
  int              nDecFLListNum;
  int              nCount;
  char             *szDecFLFileName;
  char             *szExtension;
  char             szSprite[10];
  char             szFileType[4];

  // Load Messages file
  sRegs.r[0] = 6;
  sRegs.r[3] = 17 + sizeof(MESSAGES);
  _kernel_swi (OS_Module, & sRegs, & sRegs);
  pcMessages = (char *)sRegs.r[2];
  strcpy(pcMessages + 16,MESSAGES);
  sRegs.r[0] = (int)pcMessages;
  sRegs.r[1] = (int)(pcMessages + 16);
  sRegs.r[2] = 0;
  _kernel_swi (MessageTrans_OpenFile, & sRegs, & sRegs);

  // Initialise task
  sRegs.r[0] = 300;
  sRegs.r[1] = 0x4b534154;
  sRegs.r[2] = (int)(Tag ("Tsk"));
  sRegs.r[3] = (int)anUserMessages;
  _kernel_swi (Wimp_Initialise, & sRegs, & sRegs);
  nVersion = sRegs.r[0];
  gnTaskHandle = sRegs.r[1];

  // Load sprites
  gpcSprites = LoadSprites (SPRITES);

  // Load templates
  for (nCount = 0; nCount < 256; nCount++)
  {
    gacFontRef[nCount] = 0;
  }
  (char *)(sRegs.r[1]) = TEMPLATES;
  _kernel_swi (Wimp_OpenTemplate, & sRegs, & sRegs);
  gwhMain = LoadTemplate ("Main", gpcSprites);
  gwhSave = LoadTemplate ("Save", NULL);
  gwhPass = LoadTemplate ("Passwords", NULL);
  gwhList = LoadTemplate ("List", NULL);
  gwhWarn = LoadTemplate ("Warning", NULL);

  // Create menus
  gpcIconBarMenu = CreateMenu (Tag ("Menu1"));

  // Close templates
  _kernel_swi (Wimp_CloseTemplate, & sRegs, & sRegs);

  // Create file list
  LoadFileList (argc, argv);
  nDecFLListNum = DecFLGetNum ();

  for (nCount = 0; nCount < nDecFLListNum; nCount++)
  {
    szDecFLFileName = DecFLGetLeafname (nCount);
    szExtension = strchr (szDecFLFileName, '/');
    if (!szExtension)
    {
      strcpy (szSprite, "small_ffd");
    }
    else
    {
      sRegs.r[0] = 3;
      sRegs.r[1] = (int)(szExtension + 1);
      sRegs.r[2] = 0;
      _kernel_swi (MimeMap_Translate, & sRegs, & sRegs);
      sprintf(szFileType, "%03x", sRegs.r[3]);
      sprintf(szSprite, "small_%s", szFileType);
    }

    sRegs.r[0] = 40;
    sRegs.r[2] = (int)szSprite;
    psError = _kernel_swi (Wimp_SpriteOp, & sRegs, & sRegs);

    if (psError)
    {
      sprintf(szSprite, "file_%s", szFileType);
      sRegs.r[0] = 40;
      psError = _kernel_swi (Wimp_SpriteOp, & sRegs, & sRegs);

      if (psError)
      {
        strcpy (szSprite, "small_ffd");
      }
    }

    AddFileToList (szDecFLFileName, szSprite);
  }
  if (nDecFLListNum > 0)
  {
    SetIconSelectionState (TRUE, gwhList, 1);
  }

  // Open main window
  OpenMainWindow ();

  if (DecryptBadSyntax ())
  {
    ShowErrorTag ("Er3", FALSE);
  }

  // Main polling loop
  //////////////////////////////////////////////////////////////////
  do
  {
    sRegs.r[0] = FLAGS;
    sRegs.r[1] = (int)cBlock;

    _kernel_swi (Wimp_Poll, & sRegs, & sRegs);
    switch (sRegs.r[0])
    {
      case  0: // Null
        break;
      case  1: // Redraw window
        break;
      case  2: // Open window
        OpenWindow (cBlock);
        break;
      case  3: // Closewindow
        CloseWindow (cBlock);
        break;
      case  4: // Pointer leaving window
        break;
      case  5: // Pointer entering window
        break;
      case  6:
        MouseClick (cBlock);
        break;
      case  7: // User drag box
        UserDragBox (cBlock);
        break;
      case  8: // Keys
        Keys (cBlock);
        break;
      case  9:
        MenuSelect (cBlock);
        break;
      case 10: // Scroll request
        break;
      case 11: // Lose caret
        break;
      case 12: // Gain caret
        break;
      case 17: // Receive message
      case 18:
        Receive (cBlock);
        break;
      case 19: // UserMessage Acknowledge
        Acknowledged (cBlock);
        break;
      default: // Default
        break;
    }
  } while TRUE;

  //////////////////////////////////////////////////////////////////

  return 0;
}

// Poll 17,18: Message received
void Receive (char * cBlock)
{
  switch (*(int*)(cBlock + 16))
  {
    case  0:
      Quit ();
      break;
    case  1:
      //DataSave (cBlock);
      break;
    case  2:
      DataSaveAck (cBlock);
      break;
    case  3:
      //DataLoad (cBlock);
      break;
    case  6:
      RamFetch (cBlock);
      break;
    case  7:
      //RamTransmit (cBlock);
      break;
    case 0x502:
      Help (cBlock);
      break;
  }
}

// Poll 19: Message acknowledge received
void Acknowledged (char * cBlock)
{
  switch (*(int*)(cBlock + 16))
  {
    case 0x4af80:
      OpenURLReturned (cBlock);
      break;
  }
  gnMessageMyRef = 0;
}

// Quit task
void Quit (void)
{
  _kernel_swi_regs sRegs;
  int              nCount;
  int              nRemove;

  // Free the fonts
  for (nCount = 0; nCount < (int)sizeof(gacFontRef); nCount++)
  {
    if (gacFontRef[nCount])
    {
      for (nRemove = 0; nRemove < gacFontRef[nCount]; nRemove++)
      {
        sRegs.r[0] = nCount;
        _kernel_swi (Font_LoseFont, & sRegs, & sRegs);
      }
    }
  }

  // Close the program
  _kernel_swi (Wimp_CloseDown, & sRegs, & sRegs);
}

// Obtain string from Messages file
char * Tag (char * szTag)
{
  _kernel_swi_regs sRegs;

  sRegs.r[0] = (int)pcMessages;
  sRegs.r[1] = (int)szTag;
  sRegs.r[2] = (int)(gpcTemp + 256);
  sRegs.r[3] = 256;
  sRegs.r[4] = 0;
  sRegs.r[5] = 0;
  sRegs.r[6] = 0;
  sRegs.r[7] = 0;
  _kernel_swi (MessageTrans_Lookup, & sRegs, & sRegs);

  return gpcTemp + 256;
}

// Create window from Templates file with sprites
int LoadTemplate (char * szWindowTitle, char * pcSpriteArea)
{
  _kernel_swi_regs sRegs;
  char *           pcWindow;
  char *           pcIndirected;
  int              nIndirectedSize;
  char             szTitle[12];

  sRegs.r[1] = 0;
  sRegs.r[5] = (int)szWindowTitle;
  sRegs.r[6] = 0;
  _kernel_swi (Wimp_LoadTemplate, & sRegs, & sRegs);
  pcWindow = malloc (sRegs.r[1]);
  nIndirectedSize = sRegs.r[2];
  pcIndirected = malloc (nIndirectedSize);
  strncpy (szTitle, szWindowTitle, 12);

  sRegs.r[1] = (int)pcWindow;
  sRegs.r[2] = (int)pcIndirected;
  sRegs.r[3] = (int)(pcIndirected + nIndirectedSize);
  sRegs.r[4] = (int)gacFontRef;
  sRegs.r[5] = (int)szTitle;
  sRegs.r[6] = 0;
  _kernel_swi (Wimp_LoadTemplate, & sRegs, & sRegs);
  if (pcSpriteArea)
  {
    *(int*)(pcWindow + 64) = (int)pcSpriteArea;
  }
  _kernel_swi (Wimp_CreateWindow, & sRegs, & sRegs);

  free(pcWindow);

  return sRegs.r[0];
}

void OpenMainWindow (void)
{
  _kernel_swi_regs sRegs;
  char             cBlock[72];
  int              nHeight;
  int              nWidth;
  int              nEigFactor;
  int              nPosition;

  *(int*)(cBlock +  0) = gwhMain;
  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);
  *(int*)(cBlock + 28) = -1;

  nWidth  = *(int*)(cBlock + 12) - *(int*)(cBlock +  4);
  nHeight = *(int*)(cBlock + 16) - *(int*)(cBlock +  8);

  sRegs.r[0] = -1;
  sRegs.r[1] = 4;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nEigFactor = sRegs.r[2];
  sRegs.r[1] = 11;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nPosition = ((sRegs.r[2] << nEigFactor) - nWidth) / 2;
  *(int*)(cBlock +  4) = nPosition;
  *(int*)(cBlock + 12) = nPosition + nWidth;

  sRegs.r[0] = -1;
  sRegs.r[1] = 5;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nEigFactor = sRegs.r[2];
  sRegs.r[1] = 12;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nPosition = ((sRegs.r[2] << nEigFactor) - nHeight) / 2;
  *(int*)(cBlock +  8) = nPosition;
  *(int*)(cBlock + 16) = nPosition + nHeight;

  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);

  *(int*)(cBlock + 36) = gwhList;
  sRegs.r[1] = (int)(cBlock + 36);
  _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);

  *(int*)(cBlock + 36 + 12) += *(int*)(cBlock +  4)
                             - *(int*)(cBlock +  4 + 36)
                             + LISTXOFFSET;

  *(int*)(cBlock + 36 +  4)  = *(int*)(cBlock +  4)
                             + LISTXOFFSET;

  *(int*)(cBlock + 36 + 16) += *(int*)(cBlock +  8)
                             - *(int*)(cBlock +  8 + 36)
                             + LISTYOFFSET;

  *(int*)(cBlock + 36 +  8)  = *(int*)(cBlock +  8)
                             + LISTYOFFSET;

  *(int*)(cBlock + 36 + 28)  = *(int*)(cBlock + 28);

  _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);
}



// Open window given window block
void OpenWindow (char * cBlock)
{
  _kernel_swi_regs sRegs;

  if (*(int*)(cBlock +  0) == gwhMain)
  {
    *(int*)(cBlock + 36) = gwhList;
    sRegs.r[1] = (int)(cBlock + 36);
    _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);

    *(int*)(cBlock + 36 + 12) += *(int*)(cBlock +  4)
                               - *(int*)(cBlock +  4 + 36)
                               + LISTXOFFSET;

    *(int*)(cBlock + 36 +  4)  = *(int*)(cBlock +  4)
                               + LISTXOFFSET;

    *(int*)(cBlock + 36 + 16) += *(int*)(cBlock +  8)
                               - *(int*)(cBlock +  8 + 36)
                               + LISTYOFFSET;

    *(int*)(cBlock + 36 +  8)  = *(int*)(cBlock +  8)
                               + LISTYOFFSET;

    *(int*)(cBlock + 36 + 28)  = *(int*)(cBlock + 28);

    _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);

    *(int*)(cBlock + 28) = gwhList;
    sRegs.r[1] = (int)cBlock;
    _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);
  }
  else
  {
    sRegs.r[1] = (int)cBlock;
    _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);
  }
}

// Process mouse clicks
void MouseClick (char * cBlock)
{
  int              nXpos       = *(int*)(cBlock +  0);
  int              nYpos       = *(int*)(cBlock +  4);
  int              nButton     = *(int*)(cBlock +  8);
  int              whWindow    = *(int*)(cBlock + 12);
  int              ihIcon      = *(int*)(cBlock + 16);
  char             *szFileIcon;

  if (whWindow == -2)
  {
    switch (nButton)
    {
      case  4:
        OpenMainWindow();
        break;
      case  2:
        OpenMenu (gpcIconBarMenu, nXpos - 64, 96 + 44 * 2);
        break;
    }
  }

  if (whWindow == gwhMain)
  {
    if (nButton == 2)
    {
      OpenMenu (gpcIconBarMenu, nXpos - 64, nYpos);
    }
    else
    {
      switch (ihIcon)
      {
        case  1: // Cancel
          MainCancel ();
          break;
        case  0: // Save
          MainSave (nXpos - 68, nYpos + 48);
          break;
        case  3: // Email
          OpenURL (EMAIL);
          break;
        case  4: // Website
          OpenWebsite ();
          break;
        case  5: // Open CD
          OpenCDFiler ();
          break;
      }
    }
  }

  if (whWindow == gwhSave)
  {
    switch (ihIcon)
    {
      case  3: // Save drag
        if (nButton & 0x50)
        {
          szFileIcon = GetIconText (gwhSave, 3);
          Drag (whWindow, ihIcon, szFileIcon);
          geSaveType = SAVETYPE_FILE;
        }
        break;
      case  1: // Cancel
        CloseMenu ();
        break;
      case  0: // Save
        SaveSave ();
        break;
    }
  }

  if (whWindow == gwhPass)
  {
    if (nButton == 2)
    {
      OpenMenu (gpcIconBarMenu, nXpos - 64, nYpos);
    }
    else
    {
      switch (ihIcon)
      {
        case  2: // Save drag
          if (nButton & 0x50)
          {
            DragBox (whWindow, ihIcon);
            geSaveType = SAVETYPE_PASSWORD;
          }
          break;
        case  1: // Cancel
          PassCancel ();
          break;
        case  0: // Save
          PassSave ();
          break;
      }
    }
  }

  if (whWindow == gwhWarn)
  {
    switch (ihIcon)
    {
      case  0: // OK
        CloseWindowHandle (gwhWarn);
        if (gboWarnQuit)
        {
          Quit ();
        }
        break;
    }
  }

  if (whWindow == gwhList)
  {
    if (nButton == 2)
    {
      OpenMenu (gpcIconBarMenu, nXpos - 64, nYpos);
    }
    if (nButton & 0x50)
    {
      ListSave (nXpos, nYpos, ihIcon);
    }
  }

  if (whWindow == gawhMenuWinHandle[0])
  {
    switch (ihIcon)
    {
      case  8: // Email
        OpenURL (EMAIL);
        if (nButton != 1)
        {
          CloseMenu ();
        }
        break;
      case  9: // Website
        OpenURL (WEBSITE);
        if (nButton != 1)
        {
          CloseMenu ();
        }
        break;
    }
  }
}

// Open a window on screen that is currently closed
void OpenWindowInit(int whWindow)
{
  char             cBlock[36];
  _kernel_swi_regs sRegs;

  *(int*)(cBlock +  0) = whWindow;
  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);
  *(int*)(cBlock + 28) = -1;
  _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);
}

// Open a window in the centre of the screen
void OpenWindowInitCentre(int whWindow)
{
  char             cBlock[36];
  _kernel_swi_regs sRegs;
  int              nHeight;
  int              nWidth;
  int              nEigFactor;
  int              nPosition;

  *(int*)(cBlock +  0) = whWindow;
  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);
  *(int*)(cBlock + 28) = -1;

  nWidth  = *(int*)(cBlock + 12) - *(int*)(cBlock +  4);
  nHeight = *(int*)(cBlock + 16) - *(int*)(cBlock +  8);

  sRegs.r[0] = -1;
  sRegs.r[1] = 4;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nEigFactor = sRegs.r[2];
  sRegs.r[1] = 11;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nPosition = ((sRegs.r[2] << nEigFactor) - nWidth) / 2;
  *(int*)(cBlock +  4) = nPosition;
  *(int*)(cBlock + 12) = nPosition + nWidth;

  sRegs.r[0] = -1;
  sRegs.r[1] = 5;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nEigFactor = sRegs.r[2];
  sRegs.r[1] = 12;
  _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
  nPosition = ((sRegs.r[2] << nEigFactor) - nHeight) / 2;
  *(int*)(cBlock +  8) = nPosition;
  *(int*)(cBlock + 16) = nPosition + nHeight;

  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);
}

// Close a window
void CloseWindow (char * cBlock)
{
  _kernel_swi_regs sRegs;

  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_CloseWindow, & sRegs, & sRegs);

  if ((*(int*)(cBlock +  0) == gwhMain)
     || (*(int*)(cBlock +  0) == gwhPass))
  {
    Quit ();
  }
}

// Close window given handle
void CloseWindowHandle (int whWindow)
{
  char             cBlock[4];
  _kernel_swi_regs sRegs;

  *(int*)(cBlock +  0) = whWindow;
  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_CloseWindow, & sRegs, & sRegs);

  if (whWindow == gwhMain)
  {
    *(int*)(cBlock +  0) = gwhList;
    _kernel_swi (Wimp_CloseWindow, & sRegs, & sRegs);
  }
}

// Create a window from a text string - usually kept in the messages file
char * CreateMenu (char * szMenu)
{
  char *           pcMenu;
  char *           pcBuffer;
  char *           nAt = 0;
  char *           nAt2 = 0;
  int              nWidth = 0;
  unsigned int     uFlags;
  char             szMenuString[512];
  char *           pcMenuString;
  char *           pcN;

  pcMenu = malloc (1024);
  pcBuffer = pcMenu + 512;

  nAt = strchr (szMenu, ',');
  if (!nAt)
  {
    nAt = (char *)strlen (szMenu);
  }
  else
  {
    nAt -= (int)szMenu;
  }
  strncpy (szMenuString, szMenu, (int)nAt);
  szMenuString[(int)nAt] = 0;

  strncpy (pcMenu, szMenuString, 12);
  pcMenu[12] = 7;
  pcMenu[13] = 2;
  pcMenu[14] = 7;
  pcMenu[15] = 0;
  *(int*)(pcMenu + 20) = 44;
  *(int*)(pcMenu + 24) = 0;
  pcN = pcMenu + 28;
  do
  {
    *(int*)(pcN +  4) = -1;
    *(int*)(pcN +  8) = (7<<24)+(1<<5)+1;
    nAt2 = nAt + 1;

    nAt = strchr (szMenu + (int)nAt2, ',');
    if (!nAt)
    {
      nAt = (char *)strlen (szMenu) + 1;
    }
    else
    {
      nAt -= (int)szMenu;
    }
    strncpy (szMenuString, szMenu + (int)nAt2, (int)nAt - (int)nAt2);
    szMenuString[(int)nAt - (int)nAt2] = 0;

    pcMenuString = szMenuString;

    uFlags = 0u;
    if (pcMenuString[0] == '+')
    {
      uFlags = 1u;
      pcMenuString++;
    }
    if (pcMenuString[0] == '-')
    {
      uFlags |= 2u;
      pcMenuString++;
    }
    if (pcMenuString[0] == '|')
    {
      uFlags |= 4u;
      pcMenuString++;
    }
    if (pcMenuString[0] == '>')
    {
      pcMenuString++;
      if (gnMenuWins < (int)sizeof(gawhMenuWinHandle))
      {
        gawhMenuWinHandle[gnMenuWins] = LoadTemplate (pcMenuString, NULL);
        *(int*)(pcN +  4) = gawhMenuWinHandle[gnMenuWins];
        gnMenuWins++;
      }
    }

    if (strlen (pcMenuString) > 12)
    {
      *(int*)(pcN +  8) |= 256;
      *(int*)(pcN + 12) = (int)pcBuffer;
      *(int*)(pcN + 16) = 0;
      *(int*)(pcN + 20) = strlen (pcMenuString) + 1;
      strcpy (pcBuffer, pcMenuString);
      pcBuffer += strlen (pcMenuString) + 1;
    }
    else
    {
      strncpy (pcN + 12, pcMenuString, 12);
    }
    *(unsigned int*)(pcN +  0) = uFlags;;
    if ((int)strlen (pcMenuString) > nWidth)
    {
      nWidth = strlen (pcMenuString);
    }
    pcN += 24;
  } while ((int)nAt < (int)strlen (szMenu));

  *(int*)(pcMenu + 16) = (nWidth + 1) * 16;
  *(unsigned int*)(pcN - 24) = uFlags | 0x80;

  return pcMenu;
}

#if defined _DEBUG
// Report a debug message
void Report (char * szMessage)
{
  _kernel_swi_regs sRegs;

  sRegs.r[0] = (int)szMessage;
  _kernel_swi (0x54c86, & sRegs, & sRegs);
}

// Report a debug message with variable
void ReportVar (char * szFormat, int nVariable)
{
  _kernel_swi_regs sRegs;
  char             szReport[255];

  sprintf (szReport, szFormat, nVariable);
  sRegs.r[0] = (int)szReport;
  _kernel_swi (0x54c86, & sRegs, & sRegs);
}
#endif // _DEBUG

// Open a given menu at the given position on screen
void OpenMenu (char * pcMenu, int nXpos, int nYpos)
{
  _kernel_swi_regs sRegs;

  sRegs.r[1] = (int)pcMenu;
  sRegs.r[2] = nXpos;
  sRegs.r[3] = nYpos;
  _kernel_swi (Wimp_CreateMenu, & sRegs, & sRegs);

  gnMenuXpos = nXpos;
  gnMenuYpos = nYpos;
  gpcMenuCurrent = pcMenu;
}

// Act on menu selections
void MenuSelect (char * cBlock)
{
  _kernel_swi_regs sRegs;

  sRegs.r[1] = (int)(cBlock + 20);
  _kernel_swi (Wimp_GetPointerInfo, & sRegs, & sRegs);
  switch (*(int*)(cBlock))
  {
    case 1:
      Quit ();
      break;
    default:
      break;
  }
  if ((cBlock[28] & 1))
  {
    sRegs.r[1] = (int)gpcMenuCurrent;
    sRegs.r[2] = gnMenuXpos;
    sRegs.r[3] = gnMenuYpos;
    _kernel_swi (Wimp_CreateMenu, & sRegs, & sRegs);
  }
}

// User has finished dragging an object
void UserDragBox (char * cBlock)
{
  _kernel_swi_regs sRegs;
  char             *szFileName;
  int              whWindow;

  _kernel_swi (DragASprite_Stop, & sRegs, & sRegs);
  gboDrag = FALSE;

  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_GetPointerInfo, & sRegs, & sRegs);

  whWindow = *(int*)(cBlock + 12);

  if ((whWindow != gwhMain)
     && (whWindow != gwhSave)
     && (whWindow != gwhList)
     && (whWindow != gwhWarn))
  {
    switch (geSaveType)
    {
      case SAVETYPE_FILE:
        *(int*)(cBlock + 20) = *(int*)(cBlock + 12);
        *(int*)(cBlock + 24) = *(int*)(cBlock + 16);
        *(int*)(cBlock + 28) = *(int*)(cBlock +  0);
        *(int*)(cBlock + 32) = *(int*)(cBlock +  4);
        *(int*)(cBlock + 36) = 0;
        *(int*)(cBlock + 40) = gnSaveFileType; // filetype

        szFileName = GetIconText (gwhSave, 2);

        while (strchr(szFileName, '.'))
        {
          szFileName = strchr(szFileName, '.') + 1;
        }

        strcpy(cBlock + 44, szFileName);
        *(int*)(cBlock +  0) = (44 + 4 + strlen (szFileName)) & ~3;
        *(int*)(cBlock + 12) = 0;
        *(int*)(cBlock + 16) = 1;

        sRegs.r[0] = 17;
        sRegs.r[1] = (int)(cBlock +  0);
        sRegs.r[2] = *(int*)(cBlock + 20);
        sRegs.r[3] = *(int*)(cBlock + 24);
        _kernel_swi (Wimp_SendMessage, & sRegs, & sRegs);
        break;
      case SAVETYPE_PASSWORD:
        *(int*)(cBlock + 20) = *(int*)(cBlock + 12);
        *(int*)(cBlock + 24) = *(int*)(cBlock + 16);
        *(int*)(cBlock + 28) = *(int*)(cBlock +  0);
        *(int*)(cBlock + 32) = *(int*)(cBlock +  4);
        *(int*)(cBlock + 36) = 255;
        *(int*)(cBlock + 40) = 0xfff; // filetype (text file)

        strcpy(cBlock + 44, "PassSend");
        *(int*)(cBlock +  0) = 44 + 12;
        *(int*)(cBlock + 12) = 0;
        *(int*)(cBlock + 16) = 1;

        sRegs.r[0] = 17;
        sRegs.r[1] = (int)(cBlock +  0);
        sRegs.r[2] = *(int*)(cBlock + 20);
        sRegs.r[3] = *(int*)(cBlock + 24);
        _kernel_swi (Wimp_SendMessage, & sRegs, & sRegs);
        break;
      default:
        break;
    }
  }
}

// Act on user key presses
void Keys (char * cBlock)
{
  _kernel_swi_regs sRegs;
  int              whWindow;
  int              ihIcon;
  int              nKey;

  whWindow = *(int*)(cBlock +  0);
  ihIcon = *(int*)(cBlock +  4);
  nKey = *(int*)(cBlock + 24);

  switch (nKey)
  {
    case 13:
      if (whWindow == gwhSave)
      {
        SaveSave ();
      }
      if (whWindow == gwhPass)
      {
        PassSave ();
      }
      if (whWindow == gwhWarn)
      {
        CloseWarning ();
      }
      break;
    case 0x1b:
      if (whWindow == gwhWarn)
      {
        CloseWarning ();
      }
      break;
    default:
      sRegs.r[0] = nKey;
      _kernel_swi (Wimp_ProcessKey, & sRegs, & sRegs);
      break;
  }
}

// Get the text string from an icon
char * GetIconText (int whWindow, int ihIcon)
{
  _kernel_swi_regs sRegs;
  char             *szString;

  *(int*)(gpcTemp +  0) = whWindow;
  *(int*)(gpcTemp +  4) = ihIcon;
  sRegs.r[1] = (int)gpcTemp;
  _kernel_swi (Wimp_GetIconState, & sRegs, & sRegs);
  if ((*(int*)(gpcTemp + 24) & 0x100))
  {
    szString = (char *)(*(int*)((gpcTemp + 28)));
  }
  else
  {
    szString = (gpcTemp + 28);
  }
  return szString;
}

// Set the selection state from an icon
void SetIconSelectionState (BOOL boState, int whWindow, int ihIcon)
{
  _kernel_swi_regs sRegs;

  *(int*)(gpcTemp +  0) = whWindow;
  *(int*)(gpcTemp +  4) = ihIcon;
  if (boState)
  {
    *(int*)(gpcTemp +  8) = (1<<21);
  }
  else
  {
    *(int*)(gpcTemp +  8) = (0<<21);
  }
  *(int*)(gpcTemp + 12) = (1<<21);

  sRegs.r[1] = (int)gpcTemp;
  _kernel_swi (Wimp_SetIconState, & sRegs, & sRegs);
}

// Set the text string for an icon
void SetIconText (char * szText, int whWindow, int ihIcon)
{
  _kernel_swi_regs sRegs;

  *(int*)(gpcTemp +  0) = whWindow;
  *(int*)(gpcTemp +  4) = ihIcon;
  sRegs.r[1] = (int)gpcTemp;
  _kernel_swi (Wimp_GetIconState, & sRegs, & sRegs);

  if ((*(int*)(gpcTemp + 24) & 0x100))
  {
    strcpy ((char *)(*(int*)(gpcTemp + 28)), szText);
  }
  else
  {
    strcpy ((gpcTemp + 28), szText);
  }

  *(int*)(gpcTemp +  8) = 0;
  *(int*)(gpcTemp + 12) = 0;
  sRegs.r[1] = (int)gpcTemp;
  _kernel_swi (Wimp_SetIconState, & sRegs, & sRegs);
}

// Acknowledge that you received a DataSave message
// Usually followed by a DataLoad message
void DataSaveAck (char * cBlock)
{
  _kernel_swi_regs sRegs;
  char             *szFilename;
  int              nPassSize;
  char             *szPassword;

  CloseMenu ();

  switch (geSaveType)
  {
      case SAVETYPE_FILE:
        szFilename = cBlock + 44;
        // Save the file to the given filename
        SetIconText (szFilename, gwhSave, 2);
        DecryptSetPath (szFilename);
        Passwords ();
        break;
      case SAVETYPE_PASSWORD:
        szFilename = cBlock + 44;
        // Save the file to the given filename
        szPassword = GetIconText (gwhPass, 2);
        nPassSize = strlen (szPassword);
        sRegs.r[0] = 10;
        sRegs.r[1] = (int)szFilename;
        sRegs.r[2] = 0xfff;
        sRegs.r[4] = (int)szPassword;
        sRegs.r[5] = (int)(szPassword + nPassSize);
        err (_kernel_swi (OS_File, & sRegs, & sRegs));

        *(int*)(cBlock + 12) = *(int*)(cBlock +  8);
        *(int*)(cBlock + 16) = 3;
        sRegs.r[0] = 17;
        sRegs.r[1] = (int)cBlock;
        sRegs.r[2] = (*(int*)(cBlock +  4));

        _kernel_swi (Wimp_SendMessage, & sRegs, & sRegs);
        break;
      default:
        break;
  }
}

// Copy the data from here to the external program
// Reply with RamTransmit
void RamFetch (char * cBlock)
{
  _kernel_swi_regs sRegs;
  char             *szPassword;
  int              nPassLength;
  int              nDestHandle;

  CloseMenu ();

  switch (geSaveType)
  {
    case SAVETYPE_PASSWORD:
      nDestHandle = *(int*)(cBlock +  4);

      szPassword = GetIconText (gwhPass, 2);
      nPassLength = (int)strlen (szPassword);

      if (nPassLength < *(int*)(cBlock + 24))
      {
        sRegs.r[0] = gnTaskHandle;
        sRegs.r[1] = (int)szPassword; // Address of source data to transfer
        sRegs.r[2] = nDestHandle;
        sRegs.r[3] = *(int*)(cBlock + 20);
        sRegs.r[4] = nPassLength; // Length of buffer (byte aligned)
        _kernel_swi (Wimp_TransferBlock, & sRegs, & sRegs);

        *(int*)(cBlock +  0) = 28;
        *(int*)(cBlock + 12) = *(int*)(cBlock +  8);
        *(int*)(cBlock + 16) = 7;
        *(int*)(cBlock + 24) = nPassLength;
        sRegs.r[0] = 17;
        sRegs.r[1] = (int)cBlock;
        sRegs.r[2] = nDestHandle;
        _kernel_swi (Wimp_SendMessage, & sRegs, & sRegs);
      }
      break;
    default:
      break;
  }
}

// Response to a Help message
void Help (char * cBlock)
{
  _kernel_swi_regs sRegs;
  int              whWindow;
  int              ihIcon;
  char             szHelpText[236];
  int              nStrLen;
  char             szTag[16];
  int              nMenu[2];
  BOOL             boComplete;
  char             nWinNum = 0;

  whWindow = *(int*)(cBlock + 32);
  ihIcon = *(int*)(cBlock + 36);
  boComplete = FALSE;

  if (whWindow == -2)
  {
    strncpy (szHelpText, TagCheck ("H0"), sizeof(szHelpText));
    szHelpText[sizeof(szHelpText) - 1] = 0;
    boComplete = TRUE;
  }

  if (whWindow == gwhMain)
  {
    nWinNum = 1;
  }

  if (whWindow == gawhMenuWinHandle[0])
  {
    nWinNum = 2;
  }

  if (whWindow == gwhList)
  {
    nWinNum = 4;
  }

  if (whWindow == gwhSave)
  {
    nWinNum = 5;
  }

  if (whWindow == gwhPass)
  {
    nWinNum = 6;
  }

  if (whWindow == gwhWarn)
  {
    nWinNum = 7;
  }

  if (nWinNum)
  {
    sprintf (szTag, "H%d", nWinNum);
    strncpy (szHelpText, TagCheck (szTag), sizeof(szHelpText));
    szHelpText[sizeof(szHelpText) - 1] = 0;
    nStrLen = strlen(szHelpText);
    sprintf (szTag, "H%dI%d", nWinNum, ihIcon);
    strncpy (szHelpText + nStrLen, TagCheck (szTag), sizeof(szHelpText) - nStrLen);
    boComplete = TRUE;
  }

  if (!boComplete)
  {
    sRegs.r[0] = 1;
    sRegs.r[1] = (int)gpcTemp;
    sRegs.r[2] = whWindow;
    sRegs.r[3] = ihIcon;
    _kernel_swi (Wimp_GetMenuState, & sRegs, & sRegs);

    nMenu[0] = *(int*)(gpcTemp +  0);
    nMenu[1] = *(int*)(gpcTemp +  4);

    if (gpcMenuCurrent == gpcIconBarMenu)
    {
      sprintf (szTag, "H3I%d", nMenu[0]);
      strncpy (szHelpText, TagCheck (szTag), sizeof(szHelpText));
      boComplete = TRUE;
    }
  }

  if (boComplete)
  {
    *(int*)(cBlock +  0) = (24 + strlen(szHelpText)) & (~3);
    *(int*)(cBlock + 12) = *(int*)(cBlock +  8);
    *(int*)(cBlock + 16) = 0x503;
    strncpy (cBlock + 20, szHelpText, sizeof(szHelpText));

    sRegs.r[0] = 17;
    sRegs.r[1] = (int)cBlock;
    sRegs.r[2] = (*(int*)(cBlock +  4));

    _kernel_swi (Wimp_SendMessage, & sRegs, & sRegs);
  }
}

// Obtain string from Messages file if it exists
char * TagCheck (char * szTag)
{
  _kernel_swi_regs sRegs;

  sRegs.r[0] = (int)pcMessages;
  sRegs.r[1] = (int)szTag;
  sRegs.r[2] = (int)gpcTemp;
  sRegs.r[3] = 256;
  sRegs.r[4] = 0;
  _kernel_swi (MessageTrans_EnumerateTokens, & sRegs, & sRegs);

  if (sRegs.r[2] == 0)
  {
    strcpy (gpcTemp, "");
  }
  else
  {
    sRegs.r[0] = (int)pcMessages;
    sRegs.r[1] = (int)szTag;
    sRegs.r[2] = (int)gpcTemp;
    sRegs.r[3] = 256;
    sRegs.r[4] = 0;
    sRegs.r[5] = 0;
    sRegs.r[6] = 0;
    sRegs.r[7] = 0;
    _kernel_swi (MessageTrans_Lookup, & sRegs, & sRegs);
    gpcTemp[sRegs.r[2]] = 13;
    gpcTemp[sRegs.r[2] + 1] = 13;
  }

  return gpcTemp;
}

void MainCancel (void)
{
  CloseWindowHandle (gwhMain);
  Quit ();
}

void SaveSave (void)
{
  char             *szFilename;

  szFilename = GetIconText (gwhSave, 2);

  CloseMenu ();

  if (strchr(szFilename, '.'))
  {
    DecryptSetPath (szFilename);

    Passwords ();
  }
  else
  {
    ShowErrorTag ("Er2", FALSE);
  }
}

void Drag (int whWindow, int ihIcon, char * szIconName)
{
  _kernel_swi_regs sRegs;
  char             *pcSpriteArea;
  int              nXinc;
  int              nYinc;

  if (!gboDrag)
  {
    *(int*)(gpcTemp +  0) = whWindow;
    *(int*)(gpcTemp +  4) = ihIcon;

    sRegs.r[1] = (int)gpcTemp;
    _kernel_swi (Wimp_GetIconState, & sRegs, & sRegs);

    if ((*(int*)(gpcTemp + 24) & 0x103) == 0x102)
    {
      pcSpriteArea = (char *)*(int*)(gpcTemp + 32);
    }
    else
    {
      pcSpriteArea = 0;
    }

    *(int*)(gpcTemp + 24) = whWindow;

    sRegs.r[1] = (int)(gpcTemp + 24);
    _kernel_swi (Wimp_GetWindowInfo, & sRegs, & sRegs);

    if (pcSpriteArea == 0)
    {
      pcSpriteArea = (char *)*(int*)(gpcTemp + 24 + 68);
    }

    nXinc = *(int*)(gpcTemp + 28) - *(int*)(gpcTemp + 44);
    nYinc = *(int*)(gpcTemp + 40) - *(int*)(gpcTemp + 48);

    *(int*)(gpcTemp +  8) += nXinc;
    *(int*)(gpcTemp + 12) += nYinc;
    *(int*)(gpcTemp + 16) += nXinc;
    *(int*)(gpcTemp + 20) += nYinc;

    sRegs.r[0] = 0xc5;
    sRegs.r[1] = (int)pcSpriteArea;
    sRegs.r[2] = (int)szIconName;
    sRegs.r[3] = (int)(gpcTemp +  8);
    sRegs.r[4] = 0;

    _kernel_swi (DragASprite_Start, & sRegs, & sRegs);

    gboDrag = TRUE;
  }
}

void DragBox (int whWindow, int ihIcon)
{
  _kernel_swi_regs sRegs;
  int              nXinc;
  int              nYinc;

  if (!gboDrag)
  {
    *(int*)(gpcTemp +  0) = whWindow;
    *(int*)(gpcTemp +  4) = ihIcon;

    sRegs.r[1] = (int)gpcTemp;
    _kernel_swi (Wimp_GetIconState, & sRegs, & sRegs);

    *(int*)(gpcTemp + 24) = whWindow;

    sRegs.r[1] = (int)(gpcTemp + 24);
    _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);

    *(int*)(gpcTemp +  0) = 0;
    *(int*)(gpcTemp +  4) = 5;

    nXinc = *(int*)(gpcTemp + 28) - *(int*)(gpcTemp + 44);
    nYinc = *(int*)(gpcTemp + 40) - *(int*)(gpcTemp + 48);

    *(int*)(gpcTemp +  8) += nXinc;
    *(int*)(gpcTemp + 12) += nYinc;
    *(int*)(gpcTemp + 16) += nXinc;
    *(int*)(gpcTemp + 20) += nYinc;
    *(int*)(gpcTemp + 24) = 0;
    *(int*)(gpcTemp + 28) = 0;
    *(int*)(gpcTemp + 32) = 0;
    *(int*)(gpcTemp + 36) = 0;

    sRegs.r[1] = (int)gpcTemp;
    sRegs.r[2] = 0x4b534154;
    sRegs.r[3] = 0;

    _kernel_swi (Wimp_DragBox, & sRegs, & sRegs);

    gboDrag = TRUE;
  }
}

void DragCentred (int nXpos, int nYpos, char * szIconName)
{
  _kernel_swi_regs sRegs;
  int              nWidth;
  int              nHeight;

  if (!gboDrag)
  {
    sRegs.r[0] = 0x28;
    sRegs.r[2] = (int)szIconName;
    _kernel_swi (Wimp_SpriteOp, & sRegs, & sRegs);

    nWidth = sRegs.r[3];
    nHeight = sRegs.r[4];

    sRegs.r[0] = sRegs.r[6];
    sRegs.r[1] = 4;
    _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
    nWidth = nWidth << sRegs.r[2];

    sRegs.r[1] = 5;
    _kernel_swi (OS_ReadModeVariable, & sRegs, & sRegs);
    nHeight = nHeight << sRegs.r[2];

    *(int*)(gpcTemp +  0) = nXpos - (nWidth >> 1);
    *(int*)(gpcTemp +  4) = nYpos - (nHeight >> 1);
    *(int*)(gpcTemp +  8) = *(int*)(gpcTemp +  0) + nWidth;
    *(int*)(gpcTemp + 12) = *(int*)(gpcTemp +  4) + nHeight;

    sRegs.r[0] = 0xc5;
    sRegs.r[1] = 1;
    sRegs.r[2] = (int)szIconName;
    sRegs.r[3] = (int)(gpcTemp +  0);
    sRegs.r[4] = 0;
    _kernel_swi (DragASprite_Start, & sRegs, & sRegs);

    gboDrag = TRUE;
  }
}

void Passwords (void)
{
  char             cBlock[72];
  _kernel_swi_regs sRegs;
  char             szPasswordSend[256];

  DecryptGetPassSend (szPasswordSend);

  SetIconText (szPasswordSend, gwhPass, 2);
  SetIconText ("", gwhPass, 3);

  *(int*)(cBlock +  0) = gwhPass;
  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);
  *(int*)(cBlock + 28) = -1;

  *(int*)(cBlock + 36) = gwhMain;
  sRegs.r[1] = (int)(cBlock + 36);
  _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);

  *(int*)(cBlock + 12) += *(int*)(cBlock +  4 + 36)
                        - *(int*)(cBlock +  4);

  *(int*)(cBlock +  4)  = *(int*)(cBlock +  4 + 36);

  *(int*)(cBlock + 16) += *(int*)(cBlock +  8 + 36)
                        - *(int*)(cBlock +  8);

  *(int*)(cBlock +  8)  = *(int*)(cBlock +  8 + 36);

  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_OpenWindow, & sRegs, & sRegs);

  CloseWindowHandle (gwhMain);
}

void PassSave (void)
{
  char             szPassReceive[255];
  char             *szPassText;
  char             *szFileOut;
  BOOL             boSuccess;

  szPassText = GetIconText (gwhPass, 3);
  strncpy (szPassReceive, szPassText, sizeof(szPassReceive));
  szFileOut = DecryptGetPath ();
  boSuccess = DecryptFile (szFileOut, szPassReceive);

  CloseWindowHandle (gwhPass);

  if (boSuccess)
  {
    Quit ();
  }
  else
  {
    ShowErrorTag ("Er1", TRUE);
  }
}

void PassCancel (void)
{
  CloseWindowHandle (gwhPass);
  Quit ();
}

void AddFileToList (char * szName, char * szSpriteName)
{
  _kernel_swi_regs sRegs;
  static int       nCount = 0;
  char             cBlock[72];
  int              nHeight;
  int              nWindowWidth;
  int              nWindowHeight;
  int              nResizeHeight;
  char             *szTextBuffer;
  char             *szValidationString;

  *(int*)(cBlock +  0)  = gwhList;
  *(int*)(cBlock +  4)  = 0;
  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_GetIconState, & sRegs, & sRegs);

  nHeight = *(int*)(cBlock + 12) - *(int*)(cBlock + 20);

  *(int*)(cBlock + 12) = LISTITEMYGAP + (LISTITEMYGAP + nHeight) * nCount
                       + nHeight;
  *(int*)(cBlock + 20) = LISTITEMYGAP + (LISTITEMYGAP + nHeight) * nCount;
  *(int*)(cBlock +  4) = gwhList;

  szTextBuffer = malloc (strlen(szName) + 1);
  *(int*)(cBlock + 28) = (int)szTextBuffer;
  strcpy (szTextBuffer, szName);
  szValidationString = malloc (strlen(szSpriteName) + 2);
  *(int*)(cBlock + 32) = (int)szValidationString;
  sprintf (szValidationString, "s%s", szSpriteName);
  *(int*)(cBlock + 36) = strlen(szName) + 1;

  if (strncmp (szSpriteName, "file", 4) == 0)
  {
    *(int*)(cBlock + 24) |= (1<<11);
  }

  sRegs.r[1] = (int)(cBlock + 4);
  _kernel_swi (Wimp_CreateIcon, & sRegs, & sRegs);

  sRegs.r[1] = (int)cBlock;
  _kernel_swi (Wimp_GetWindowState, & sRegs, & sRegs);

  nWindowWidth  = *(int*)(cBlock + 12) - *(int*)(cBlock +  4);
  nWindowHeight = *(int*)(cBlock +  8) - *(int*)(cBlock + 16);

  nResizeHeight = 2 * LISTITEMYGAP + (LISTITEMYGAP + nHeight) * nCount
                + nHeight;

  if (nWindowHeight < nResizeHeight)
  {
    nResizeHeight = nWindowHeight;
  }

  *(int*)(cBlock +  4) = 0;
  *(int*)(cBlock +  8) = nResizeHeight;
  *(int*)(cBlock +  12) = nWindowWidth;
  *(int*)(cBlock +  16) = 0;

  sRegs.r[0] = gwhList;
  sRegs.r[1] = (int)(cBlock + 4);
  _kernel_swi (Wimp_SetExtent, & sRegs, & sRegs);

  nCount++;
}

void MainSave (int nXpos, int nYpos)
{
  _kernel_swi_regs sRegs;
  _kernel_oserror  *psError;
  char             *szLeafName;
  int              aihIcons[1024];
  char             *szExtension;
  char             szSprite[10];

  sRegs.r[0] = gwhList;
  sRegs.r[1] = (int)aihIcons;
  sRegs.r[2] = (1<<21);
  sRegs.r[3] = (1<<21);
  _kernel_swi (Wimp_WhichIcon, & sRegs, & sRegs);

  if (aihIcons[0] == -1)
  {
    aihIcons[0] = 1;
    aihIcons[1] = -1;
    SetIconSelectionState (TRUE, gwhList, 1);
  }

  DecFLStoreKeyPress (aihIcons[0] - 1);

  szLeafName = GetIconText (gwhList, aihIcons[0]);
  SetIconText (szLeafName, gwhSave, 2);

  szExtension = strchr (szLeafName, '/');
  if (!szExtension)
  {
    strcpy (szSprite, "file_ffd");
    gnSaveFileType = 0xffd;
  }
  else
  {
    sRegs.r[0] = 3;
    sRegs.r[1] = (int)(szExtension + 1);
    sRegs.r[2] = 0;
    _kernel_swi (MimeMap_Translate, & sRegs, & sRegs);
    gnSaveFileType = sRegs.r[3];
    sprintf(szSprite, "file_%03x", sRegs.r[3]);
  }

  sRegs.r[0] = 40;
  sRegs.r[2] = (int)szSprite;
  psError = _kernel_swi (Wimp_SpriteOp, & sRegs, & sRegs);
  if (psError)
  {
      strcpy (szSprite, "file_ffd");
  }
  SetIconText (szSprite, gwhSave, 3);

  OpenMenu ((char *)gwhSave, nXpos, nYpos);
}

void ListSave (int nXpos, int nYpos, int ihIcon)
{
  _kernel_swi_regs sRegs;
  _kernel_oserror  *psError;
  char             *szLeafName;
  char             *szExtension;
  char             szSprite[10];

  DecFLStoreKeyPress (ihIcon - 1);

  szLeafName = GetIconText (gwhList, ihIcon);
  SetIconText (szLeafName, gwhSave, 2);

  szExtension = strchr (szLeafName, '/');
  if (!szExtension)
  {
    strcpy (szSprite, "file_ffd");
    gnSaveFileType = 0xffd;
  }
  else
  {
    sRegs.r[0] = 3;
    sRegs.r[1] = (int)(szExtension + 1);
    sRegs.r[2] = 0;
    _kernel_swi (MimeMap_Translate, & sRegs, & sRegs);
    gnSaveFileType = sRegs.r[3];
    sprintf(szSprite, "file_%03x", sRegs.r[3]);
  }

  sRegs.r[0] = 40;
  sRegs.r[2] = (int)szSprite;
  psError = _kernel_swi (Wimp_SpriteOp, & sRegs, & sRegs);
  if (psError)
  {
      strcpy (szSprite, "file_ffd");
  }
  SetIconText (szSprite, gwhSave, 3);

  DragCentred (nXpos, nYpos, szSprite);
  geSaveType = SAVETYPE_FILE;
}

char * LoadSprites (char * szFileName)
{
  _kernel_swi_regs sRegs;
  char             *pcMemory;
  int              nSize;

  sRegs.r[0] = 17;
  sRegs.r[1] = (int)szFileName;
  err (_kernel_swi (OS_File, & sRegs, & sRegs));

  if (sRegs.r[4] > 0)
  {
    nSize = (sRegs.r[4] + 9) &~3;
    pcMemory = malloc (nSize);

    if (pcMemory)
    {
      *(int*)(pcMemory +  0) = nSize;
      *(int*)(pcMemory +  4) = 0;
      *(int*)(pcMemory +  8) = 16;
      *(int*)(pcMemory + 12) = 16;

      sRegs.r[0] = 0x10a;
      sRegs.r[1] = (int)pcMemory;
      sRegs.r[2] = (int)szFileName;
      err (_kernel_swi (OS_SpriteOp, & sRegs, & sRegs));
    }
  }
  else
  {
    pcMemory = NULL;
  }

  return pcMemory;
}

void OpenWebsite (void)
{
  _kernel_swi_regs sRegs;
  char             szCommand[512];

  sprintf (szCommand, "Filer_Run %s.Website.Begin/htm", DecryptGetRoot ());

  sRegs.r[0] = (int)szCommand;
  err (_kernel_swi (OS_CLI, & sRegs, & sRegs));
}

void OpenCDFiler (void)
{
  _kernel_swi_regs sRegs;
  char             szCommand[512];

  sprintf (szCommand, "Filer_OpenDir %s", DecryptGetRoot ());

  sRegs.r[0] = (int)szCommand;
  err (_kernel_swi (OS_CLI, & sRegs, & sRegs));
}

// Initiate a URL link
void OpenURL (char * szURL)
{
  _kernel_swi_regs sRegs;

  *(int*)(gpcTemp + 12) = 0;
  *(int*)(gpcTemp + 16) = 0x4af80;

  strcpy (gpcTemp + 20, szURL);

  *(int*)(gpcTemp +  0) = (strlen(szURL) + 24) &~3;

  sRegs.r[0] = 18;
  sRegs.r[1] = (int)(gpcTemp +  0);
  sRegs.r[2] = 0;
  sRegs.r[3] = 0;
  _kernel_swi (Wimp_SendMessage, & sRegs, & sRegs);

  gnMessageMyRef = *(int*)(gpcTemp +  8);
}

// No URL lancher responded, so we have to run one ourselves
void OpenURLReturned (char * cBlock)
{
  _kernel_swi_regs sRegs;
  char             szAlias[255];

  if (gnMessageMyRef == *(int*)(cBlock +  8))
  {
    if (strncmp (cBlock + 20, "mailto:", 7) == 0)
    {
      strcpy (szAlias, "URLOpen_MailTo");
    }
    else
    {
      strcpy (szAlias, "URLOpen_HTTP");
    }

    sprintf (gpcTemp, "Alias$%s", szAlias);

    sRegs.r[0] = (int)gpcTemp;
    sRegs.r[1] = 0;
    sRegs.r[2] = -1;
    sRegs.r[3] = 0;
    sRegs.r[4] = 0;
    _kernel_swi (OS_ReadVarVal, & sRegs, & sRegs);

    if (sRegs.r[2])
    {
      sprintf (gpcTemp, "%s %s", szAlias, cBlock + 20);
      sRegs.r[0] = (int)gpcTemp;
      err (_kernel_swi (Wimp_StartTask, & sRegs, & sRegs));
    }
  }
}

// Display an error from the Messages filein an error box
void ShowErrorTag (char * szTag, BOOL boQuit)
{
    _kernel_swi_regs sRegs;

    _kernel_swi (OS_WriteI + 0x07, & sRegs, & sRegs);
    SetIconText (Tag(szTag), gwhWarn, 1);
    OpenWindowInitCentre (gwhWarn);
    CloseMenu ();

    sRegs.r[0] = gwhWarn;
    sRegs.r[1] = -1;
    sRegs.r[2] = 0;
    sRegs.r[3] = 0;
    sRegs.r[4] = -1;
    sRegs.r[5] = -1;
    _kernel_swi (Wimp_SetCaretPosition, & sRegs, & sRegs);

    gboWarnQuit = boQuit;
}

// Display an error in an error box
void ShowError (_kernel_oserror * sError)
{
    _kernel_swi_regs sRegs;

    _kernel_swi (OS_WriteI + 0x07, & sRegs, & sRegs);
    SetIconText (sError->errmess, gwhWarn, 1);
    OpenWindowInitCentre (gwhWarn);
    CloseMenu ();

    sRegs.r[0] = gwhWarn;
    sRegs.r[1] = -1;
    sRegs.r[2] = 0;
    sRegs.r[3] = 0;
    sRegs.r[4] = -1;
    sRegs.r[5] = -1;
    _kernel_swi (Wimp_SetCaretPosition, & sRegs, & sRegs);
}

void CloseWarning (void)
{
  CloseWindowHandle (gwhWarn);
}

// Close the currently open menu
void CloseMenu (void)
{
  _kernel_swi_regs sRegs;

  sRegs.r[1] = -1;
  _kernel_swi (Wimp_CreateMenu, & sRegs, & sRegs);

  gnMenuXpos = 0;
  gnMenuYpos = 0;
  gpcMenuCurrent = NULL;
}









